//Prototypes
var key = "";
var NotebookId = "";
var SectionId = "";
var SelectedNoteId = "";
var UnSaved = false;
var quill;

//Custom jQuery selector containsExact
//Taken from Stack Overflow http://stackoverflow.com/questions/2338439/select-element-based-on-exact-text-contents
$.expr[":"].containsExact = function (obj, index, meta, stack) {
  return (obj.textContent || obj.innerText || $(obj).text() || "") == meta[3];
};

//Custom jQuery selector iContains. Allows for case insensitive selection of jQuery
//Taken from Stack Overflow http://stackoverflow.com/questions/8746882/jquery-contains-selector-uppercase-and-lower-case-issue
$.expr[':'].icontains = function(a, i, m) {
  return jQuery(a).text().toUpperCase()
      .indexOf(m[3].toUpperCase()) >= 0;
};

//UI Actions
$(document).ready(function(){
    $("#dropDownButton").click(function (){
        $("#dropDownButton").toggleClass("selected");
        $("#dropDownMenu").toggleClass("selected");
    });
        
    $("#signUserOut").click(function (){
        $("#userFirstName").text("");
        $("#shader").toggleClass("disabled");
        $("#loginPrompt").toggleClass("disabled");
        closeDropdown();
        emptyContent();
        $("ul#noteList").html("");
        $("input#noteListSearch").val("");
        $("#emptyNoteList").removeClass("disabled");
        $("#menuEditNote").removeClass("selected");
        $("#menuEditNote").addClass("disabled");
        $("#menuSaveNote").addClass("disabled");
        $("#menuDeleteNote").addClass("disabled");
        WL.logout();
        key = "";
        NotebookId = "";
        SectionId = "";
        SelectedNoteId = "";
        UnSaved = "";
        infoLog("Successful Logout", false)
    });
    
    $("#sessionInfoBlock").click(function (){
        $("#sessionInfoBlock").toggleClass("disabled");
    });
    
    $("#sessionInfoBlockIcon").click(function (){
        $("#sessionInfoBlock").toggleClass("disabled");
    });
      
    $("h1#noteTitle").click(function(){
       if ($('h1#noteTitle[contenteditable="true"]').length > 0 && SelectedNoteId == "")
           {
               $("h1#noteTitle").select();
           }
    });
    
    $("h1#noteTitle").keyup(function (){
        UnSaved = true;
    });
    
    $("h1#noteTitle").keypress(function (e){
        if(e.which == 13)
            {
                e.preventDefault();
            }
    });
    
    $("h1#noteTitle").focusout(function (){
        setTitle($("h1#noteTitle").text());
     });
    
    $("input#noteListSearch").keyup(function (){
        if ($("input#noteListSearch").val().toUpperCase() == '')
        {
            $('ul#noteList li').removeClass('hidden');
        }
        else
        {
            $('ul#noteList li').addClass('hidden');
            $('ul#noteList li:icontains("' + $("input#noteListSearch").val().toUpperCase() + '")').removeClass('hidden');
            $('ul#noteList li.selected').removeClass('hidden');
        }
    });
    
//Application Dialog Messages    
    $("#dialogAbout").dialog({
        autoOpen: false,
//        modal: true,
        show: {
            effect: "blind",
            duration: 500
        },
        buttons: {
            OK: function() {
                $( this ).dialog( "close" );
            }
        },
        resizeable: false,
        draggable: false,
        open: function (event, ui)
        {
            $("#shader").removeClass("disabled");
        },
        close: function (event, ui)
        {
            $("#shader").addClass("disabled");
        }
    });
    
    $("#dialogDiscardChanges").dialog({
        autoOpen: false,
        show: {
            effect: "blind",
            duration: 500
        },
        buttons: {
            'Discard Changes': function(event, ui){
                $("#dialogDiscardChanges").data('onDiscardChangesAction')();
                $(this).dialog( "close" );
            },
            'Cancel': function(event, ui){
                $(this).dialog( "close" );
            }
        },
        resizeable: false,
        draggable: false,
        open: function (event, ui)
        {
            $("#shader").removeClass("disabled");
        },
        close: function (event, ui)
        {
            $("#shader").addClass("disabled");
        }
    });
    
    $("#dialogDuplicateTitle").dialog({
        autoOpen: false,
//        modal: true,
        show: {
            effect: "blind",
            duration: 500
        },
        buttons: {
            OK: function() {
                $( this ).dialog( "close" );
            }
        },
        resizeable: false,
        draggable: false,
        open: function (event, ui)
        {
            $("#shader").removeClass("disabled");
        },
        close: function (event, ui)
        {
            $("#shader").addClass("disabled");
        }
    });
    
    $("#dialogDeleteNote").dialog({
        autoOpen: false,
        show: {
            effect: "blind",
            duration: 500
        },
        buttons: {
            'Delete Note': function(event, ui){
                $(this).dialog( "close" );
                $("#dialogDeleteNote").data('onDeleteNoteAction')();
            },
            'Cancel': function(event, ui){
                $(this).dialog( "close" );
            }
        },
        resizeable: false,
        draggable: false,
        open: function (event, ui)
        {
            $("#shader").removeClass("disabled");
        },
        close: function (event, ui)
        {
            $("#shader").addClass("disabled");
        }
    });
    
    $("#dialogNewNoteTitle").dialog({
        autoOpen: false,
        show: {
            effect: "blind",
            duration: 500
        },
        buttons: {
            'Save Note': function(event, ui){
                $("h1#noteTitle").text($("input#newNoteTitle").val());
                $(this).dialog( "close" );
                $("#dialogNewNoteTitle").data('onSaveNewNoteAction')();
            },
            'Cancel': function(event, ui){
                $(this).dialog( "close" );
            },
        },
        resizeable: false,
        draggable: false,
        open: function (event, ui)
        {
            $('input#newNoteTitle').attr('value', $("h1#noteTitle").text())
            $("#shader").removeClass("disabled");
        },
        close: function (event, ui)
        {
            $("#shader").addClass("disabled");
        }
    });
    
//Menu Buttons
    $("#aboutApp").click(function(){
        $("#dialogAbout").dialog("open");
        closeDropdown();
    });
    
    $("#menuAddDemoNote").click(function(){
        createDemoPage();
        closeDropdown();
    });
    
    $('#menuAddNote').click(function(){
        if (UnSaved)
        {
            $('#dialogDiscardChanges').data('onDiscardChangesAction', function(){
                addNote();
            }).dialog("open");
        }
        else
        {
            addNote();
        }
    });
    
    $('#menuEditNote').click(function(){
        if (!$('#menuEditNote').hasClass('selected') && !$('#menuEditNote').hasClass('disabled'))
            {
                wait();
                $('#menuEditNote').addClass('selected');
                enableEditor();
                $('h1#noteTitle').attr('contenteditable', true);
            }
    });
    
    $('#menuSaveNote').click(function(){
        if(!$('#menuSaveNote').hasClass('disabled'))
            {
                saveNote();
            }
    });
    
    $('#menuDeleteNote').click(function(){
        if (!$('#menuDeleteNote').hasClass('disabled'))
        {
            $('#dialogDeleteNote').data('onDeleteNoteAction', function(){
                deleteNote();
            }).dialog("open");
        }
    });
    
    //Nodelist Listener
    //Needed to create a listener for the entire list and then get the element that was clicked.
    //This is because using individual LI's that are loaded after the click listener is built won't have
    //the click listener associated with them.
    $("#noteList").click(function(event){
        if (UnSaved)
        {
            $('#dialogDiscardChanges').data('onDiscardChangesAction', function(){
                SelectedNoteId = $(event.target).attr("noteid");
                loadPage();
            }).dialog("open");
        }
        else
        {
            SelectedNoteId = $(event.target).attr("noteid");
            loadPage();
        }

        //console.log(event.target);
        //console.log(event.target);
        //console.log(this.attr("noteid"));
    });
    
});

//API Helper Functions
function initialize()
{
    wait();
    var notebookExists = false;
    
    $.ajax({
        type: "GET",
        url: "https://www.onenote.com/api/v1.0/me/notes/notebooks/",
        dataType: "json",
        headers: {
            Authorization: "Bearer " + key
        },
        
    }).then(function(data){
        for (i = 0; i < data.value.length; i++)
            {
                if (data.value[i].name === NOTEBOOK_NAME)
                    {
                        notebookExists = true;
                        infoLog("Found Notebook \"" + data.value[i].name + "\" with id " + data.value[i].id);
                        NotebookId = data.value[i].id;
                        break;
                    }
            }
        
        if (!notebookExists)
            {
                createNotebook();
                return;
            }
    
        $.ajax({
            type: "GET",
            url: "https://www.onenote.com/api/v1.0/me/notes/notebooks/" + NotebookId + "/sections",
            dataType: "json",
            headers: {
                Authorization: "Bearer " + key
            },

        }).then(function(data){    
            //console.log(data);
            var sectionExists = false;
            
            for (i = 0; i < data.value.length; i++)
                {
                    if (data.value[i].name === SECTION_NAME)
                        {
//                            console.log(data);
                            pagesURL = data.value[i].pagesUrl;
                            sectionExists = true;
                            SectionId = data.value[i].id;
                            infoLog("Found Section \"" + data.value[i].name + "\" with id " + data.value[i].id);
                            ready();
                            break;
                        }
                }
            
            if (!sectionExists)
            {
                createSection();
            }
            else
            {
                listPages();
            }            
        });
    });
}

function createNotebook()
{
    $.ajax({
        url: "https://www.onenote.com/api/v1.0/me/notes/notebooks/",
        type: "POST",
        contentType: 'application/json',
        dataType: "json",
        
        headers: {
            Authorization: "Bearer " + key,
        },
        data: JSON.stringify({name: NOTEBOOK_NAME}),
        success: function (data){
            infoLog("Notebook \"" + data.name + "\" successfully created with id " + data.id)
            NotebookId = data.id;
        },
        error: function (data) {
            infoLog("Error creating notebook: " + data.responseJSON.error.message, true);
        },
    }).then(function() {
        createSection();
    });
}

function createSection()
{
    wait();
        $.ajax({
        url: "https://www.onenote.com/api/v1.0/me/notes/notebooks/" + NotebookId + "/sections",
        type: "POST",
        contentType: 'application/json',
        dataType: "json",
        
        headers: {
            Authorization: "Bearer " + key,
        },
        data: JSON.stringify({name: SECTION_NAME}),
        success: function (data){
            infoLog("Section \"" + data.name + "\" successfully created with id " + data.id)
            SectionId = data.id;
            ready();
        },
        error: function (data) {
            infoLog("Error creating section: " + data.responseJSON.error.message, true);
        },
    }).then(function() {
            createDemoPage();
    });
}

function createDemoPage()
{
    wait();
    $.ajax({
        url: "https://www.onenote.com/api/v1.0/me/notes/sections/" + SectionId + "/pages",
        type: "POST",
        contentType: 'text/html',
        headers: {
            Authorization: "Bearer " + key,
        },
        data: "<!DOCTYPE html><html><head><title>Page Zero - My First Note</title><meta name='created' content='2013-06-11T12:45:00.000-8:00'/></head><body><h2>Welcome to NoteZero!</h2><p>This is your very first NoteZero page!</p><h3>The note editor is really easy to use!</h3><p>To edit a note, simply select the note from the list and click on the edit button.</p><p>To edit the formatting of a note, simply highlight what you want to change and a WYSIWYG toolbar will appear just below your selection.</p></body></html>",
        success: function (data){
            infoLog("Page \"" + data.title + "\" successfully created with id " + data.id)
            ready();
        },
        error: function (data) {
            infoLog("Error creating page: " + data.responseJSON.error.message, true);
        },
    }).then(function(data) {
        listPages();
    });
}

function listPages()
{
    wait();
    $('ul#noteList li').removeClass("selected");
    $.ajax({
        type: "GET",
//        url: "https://www.onenote.com/api/v1.0/me/notes/pages?filter=createdByAppId%20eq%20'" + APP_ID + "'&orderby=createdTime%20asc&top=100&",
//        url: pagesURL,
        url: "https://www.onenote.com/api/v1.0/me/notes/sections/" + SectionId + "/pages?filter=createdByAppId%20eq%20'" + APP_ID + "'&orderby=createdTime%20asc&top=100&",
//        url: "https://www.onenote.com/api/v1.0/me/notes/notebooks/" + NotebookId + "/pages?top=100",
        dataType: "json",
        headers: { Authorization: "Bearer " + key },
        success: function(data)
        {
            console.log(data); //Left in to proove that API is slow when it comes to editing titles.
            $('#noteList').empty();
            if(data.value.length > 0)
                {
                    $('#emptyNoteList').addClass("disabled");
                    for (i = 0; i < data.value.length; i++)
                    {
                        $('#noteList').prepend('<li noteId="' + data.value[i].id + '" class="noteItem">' + data.value[i].title + '</li>');
                    }
                    
                    $('ul#noteList li[noteid="'+ SelectedNoteId +'"]').addClass("selected");
                    
                    infoLog("Successfully retrieved a list containing " + data.value.length + " notes." , false);
                    
                    ready();
                }
            else
            {
                $('#emptyNoteList').removeClass("disabled");
                infoLog("There were no notes in the list from the API call. The server could be experiencing technical problems." , false);
                ready();
            }
        }
    });
}

function loadPage()
{
    wait();
    UnSaved = false;
    $('#noNoteSelected').addClass('disabled');
    $('#emptyNoteArea').addClass('disabled');
    $('h1#noteTitle').attr('contenteditable', false);
    $('#menuSaveNote').addClass('disabled');
    
    $.ajax({
//        url: "https://www.onenote.com/api/v1.0/me/notes/pages/" + SelectedNoteId + "/content?preAuthenticated=true",
        url: "https://www.onenote.com/api/v1.0/me/notes/pages/" + SelectedNoteId + "/content?includeIDs=true&preAuthenticated=true",//
        url: "https://www.onenote.com/api/v1.0/me/notes/pages/" + SelectedNoteId + "/content?preAuthenticated=true",
        type: "GET",
        headers: { Authorization: "Bearer " + key },
        success: function(data){
            emptyContent();
            var title = $(data).filter("title").text();
            var pageContent = $(data).filter("div[data-id='_default']").html().trim();
            pageContent = $($.parseHTML(pageContent)).removeAttr('style');
            pageContent = $(pageContent.filter('*'))
            setTitle($(data).filter("title")[0].innerHTML);
            for (i = 0; i < pageContent.length; i++)
                {
                    $('article#noteContent').append(pageContent[i]);
                }
            infoLog("Loaded Page \"" + title + "\" with id " + SelectedNoteId + " successfully.")
            
            if (pageContent.length == 1 && $(pageContent)[0].outerHTML == '<br>')
            {
                $('#emptyNoteArea').removeClass('disabled');
            }
            
            $('#noNoteSelected').addClass('disabled');
            $('#menuEditNote').removeClass('disabled');
            $('#menuEditNote').removeClass('selected');
            $('#menuDeleteNote').removeClass('disabled');
            $('ul#noteList li').removeClass("selected");
            $('ul#noteList li[noteid="'+ SelectedNoteId +'"]').addClass("selected");
            ready();
        },
        error: function(data) {
            infoLog("Error loading note id: " + SelectedNoteId, true);
            $('#menuEditNote').addClass('disabled');
            $('#menuDeleteNote').addClass('disabled');
            $('#menuSaveNote').addClass('disabled');
            $('#noNoteSelected').removeClass('disabled');
            emptyContent();
            ready();
        },
    })    
}

function saveNote()
{
    if (SelectedNoteId == '')
    {
        $('#dialogNewNoteTitle').data('onSaveNewNoteAction', function() {
            if (checkTitle())
            {
                wait();
                $.ajax({
                    url: "https://www.onenote.com/api/v1.0/me/notes/sections/" + SectionId + "/pages",
                    type: "POST",
                    contentType: 'text/html',
                    headers: {
                        Authorization: "Bearer " + key,
                    },
                    data: "<!DOCTYPE html><html><head><title>" + $('h1#noteTitle').text() + "</title></head><body>"+ $('article#noteContent> div.ql-editor').html() +"</body></html>",
                    success: function (data){
                        infoLog("Page \"" + data.title + "\" successfully created with id " + data.id)
                        UnSaved = false;
                        $('#menuEditNote').addClass('selected');
                        $('#menuEditNote').removeClass('disabled');
                        $('#menuDeleteNote').removeClass('disabled');    
                        SelectedNoteId = data.id;
                        listPages();
                    },
                    error: function (data) {
                        infoLog("Error creating page: " + data.responseJSON.error.message, true);
                    },
                }).then(function(data) {
                    //
                });                    
            }
        });
        
        $('#dialogNewNoteTitle').dialog("open");
    }
    else
    {
        if (checkTitle())
        {
            wait();
            $.ajax({
                url: "https://www.onenote.com/api/v1.0/me/notes/pages/"+ SelectedNoteId +"/content",
                type: "PATCH",
                contentType: 'application/json',
                dataType: "json",
                headers: {
                    Authorization: "Bearer " + key,
                },
                data: JSON.stringify(
                    [
                        {'target': 'title',
                         'action': 'replace',
                         'content': $('h1#noteTitle').text()},
                        {'target': '#_default',
                         'action': 'replace',
                         'content': $('article#noteContent> div.ql-editor').html()}
                    ]
                ),
                success: function (data){
                    infoLog("Page content with title \"" + $('h1#noteTitle').text() + "\" with id " + SelectedNoteId + " has been successfully updated.");
                    UnSaved = false;
                    listPages();
                },
                error: function (data) {
                    infoLog("Error creating page: " + data.responseJSON.error.message, true);
                },
            }).then(function(data) {

            });
        }
    }
}

function deleteNote()
{
    wait();
    $('#noNoteSelected').addClass('disabled');
    $('#emptyNoteArea').addClass('disabled');

    if (SelectedNoteId == '')
    {
        emptyContent();
        infoLog("New page successfully deleted.");

        listPages();
        //TODO: REMOVE AFTER MARKING
        addNote();
    }
    else
    {
        $.ajax({
            url: "https://www.onenote.com/api/v1.0/me/notes/pages/" + SelectedNoteId,
            type: "DELETE",
            headers: {
                Authorization: "Bearer " + key,
            },
            success: function (data){
                infoLog("Page \"" + $('h1#noteTitle').text() + "\" with id " + SelectedNoteId + " successfully deleted.")
                UnSaved = false;
                emptyContent();
                listPages();
            },
            error: function (data) {
                infoLog("Error deleting note.", true);
            },
        }).then(function(data) {
            //TODO: REMOVE AFTER MARKING
            addNote();
            SelectedNoteId = '';
        });
    }
    $('#menuEditNote').addClass('disabled')
    $('#menuSaveNote').addClass('disabled')
    $('#menuDeleteNote').addClass('disabled')
        
}

//UI Helper Functions

function addNote()
{
    emptyContent();
    $('#noNoteSelected').addClass('disabled');
    $('#emptyNoteArea').addClass('disabled');
    setTitle("Untitled Note");
    $('#menuEditNote').addClass('selected');
    $('#menuDeleteNote').removeClass('disabled');
    $('ul#noteList > li').removeClass('selected');
    SelectedNoteId = '';
    enableEditor();
    infoLog("New note created.");
}

function enableEditor()
{
    $('article#noteContent').removeClass('noEditor');
    quill = new Quill('article#noteContent', {  modules: {
        toolbar: [
            [{ header: [1, 2, 3, false] }],
            ['bold', 'italic', 'underline'],
            ['image', 'link']
        ]
        },
        placeholder: 'Compose your note...',
        theme: 'bubble',
    });
    
    quill.on('text-change', function(delta, oldDelta, source){
        if (source == 'user')
            {
                UnSaved = true;
                $('#menuSaveNote').removeClass('disabled');
            }
    });
    
    $('#menuEditNote').removeClass('disabled');
    $('#menuEditNote').addClass('selected');
    $('h1#noteTitle').attr('contenteditable', true);
    $('#menuSaveNote').removeClass('disabled');
    $('#emptyNoteArea').addClass('disabled');
    ready();
}

function checkTitle()
{
    if($("h1#noteTitle").text() == '' || $('ul#noteList > li:containsExact("'+ $('h1#noteTitle').text() +'"):not([noteid="'+ SelectedNoteId +'"])').length > 0)
    {
            $('#dialogDuplicateTitle').dialog("open");
            return false;
    }
    else
    {
        return true;
    }
}

function emptyContent()
{
    quill = null;
    $('article#noteContent').addClass('noEditor');
    $('article#noteContent.noEditor').html('');
    $('ul#noteList li').removeClass('selected');
    $('#noNoteSelected').removeClass('disabled');
    $('#emptyNoteArea').addClass('disabled');
    $('h1#noteTitle').text('NoteZero');
    $('h1#noteTitle').attr('contenteditable', false);
}

function closeDropdown()
{
    $("#dropDownButton").removeClass("selected");
    $("#dropDownMenu").removeClass("selected");
}

function ready()
{
    $("#shader").addClass("disabled");
    $("#loader").addClass("disabled");
}

function wait()
{
    $("#shader").removeClass("disabled");
    $("#loader").removeClass("disabled");
}

function infoLog(message, show = false)
{
    $("#sessionInfoBlockLog").prepend("<p><span class='logDateTime'>" + "" + "</span> "+ message + "</p>");
    if (show)
        {
            $("#sessionInfoBlock").removeClass("disabled");
            ready();
        }
}

function setTitle(title)
{
    $('h1#noteTitle').text(title);
    $('input#newNoteTitle').val(title);
    $(document).prop('title', title + " - NoteZero");
}